var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Geometry/index.ts
var Geometry_exports = {};
__export(Geometry_exports, {
  default: () => GeometryLayer
});
module.exports = __toCommonJS(Geometry_exports);
var import_BaseLayer = __toESM(require("../core/BaseLayer"));
var import_models = __toESM(require("./models"));
var GeometryLayer = class extends import_BaseLayer.default {
  constructor() {
    super(...arguments);
    this.type = "GeometryLayer";
  }
  buildModels() {
    const modelType = this.getModelType();
    this.layerModel = new import_models.default[modelType](this);
    this.layerModel.initModels((models) => {
      this.models = models;
      this.renderLayers();
    });
  }
  rebuildModels() {
    this.layerModel.buildModels((models) => this.models = models);
  }
  getConfigSchema() {
    return {
      properties: {
        opacity: {
          type: "number",
          minimum: 0,
          maximum: 1
        }
      }
    };
  }
  getDefaultConfig() {
    const type = this.getModelType();
    const defaultConfig = {
      plane: {},
      sprite: {},
      billboard: {}
    };
    return defaultConfig[type];
  }
  getModelType() {
    var _a;
    const shapeAttribute = this.styleAttributeService.getLayerStyleAttribute("shape");
    const shape = (_a = shapeAttribute == null ? void 0 : shapeAttribute.scale) == null ? void 0 : _a.field;
    if (shape === "plane") {
      return "plane";
    } else if (shape === "sprite") {
      return "sprite";
    } else if (shape === "billboard") {
      return "billboard";
    } else {
      return "plane";
    }
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
