var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/core/shape/Path.ts
var Path_exports = {};
__export(Path_exports, {
  ShapeType2D: () => ShapeType2D,
  ShapeType3D: () => ShapeType3D,
  circle: () => circle,
  geometryShape: () => geometryShape,
  hexagon: () => hexagon,
  pentagon: () => pentagon,
  polygonPath: () => polygonPath,
  square: () => square,
  triangle: () => triangle
});
module.exports = __toCommonJS(Path_exports);
var ShapeType3D = /* @__PURE__ */ ((ShapeType3D2) => {
  ShapeType3D2["CYLINDER"] = "cylinder";
  ShapeType3D2["SQUARECOLUMN"] = "squareColumn";
  ShapeType3D2["TRIANGLECOLUMN"] = "triangleColumn";
  ShapeType3D2["HEXAGONCOLUMN"] = "hexagonColumn";
  ShapeType3D2["PENTAGONCOLUMN"] = "pentagonColumn";
  return ShapeType3D2;
})(ShapeType3D || {});
var ShapeType2D = /* @__PURE__ */ ((ShapeType2D2) => {
  ShapeType2D2["CIRCLE"] = "circle";
  ShapeType2D2["SQUARE"] = "square";
  ShapeType2D2["TRIANGLE"] = "triangle";
  ShapeType2D2["HEXAGON"] = "hexagon";
  ShapeType2D2["PENTAGON"] = "pentagon";
  return ShapeType2D2;
})(ShapeType2D || {});
function polygonPath(pointCount, start = 0) {
  const step = Math.PI * 2 / pointCount;
  const line = [];
  for (let i = 0; i < pointCount; i++) {
    line.push(step * i + start * Math.PI / 12);
  }
  const path = line.map((t) => {
    const x = Math.sin(t + Math.PI / 4);
    const y = Math.cos(t + Math.PI / 4);
    return [x, y, 0];
  });
  return path;
}
function circle() {
  return polygonPath(30);
}
function square() {
  return polygonPath(4);
}
function triangle() {
  return polygonPath(3);
}
function hexagon() {
  return polygonPath(6, 1);
}
function pentagon() {
  return polygonPath(5);
}
var geometryShape = {
  ["circle" /* CIRCLE */]: circle,
  ["hexagon" /* HEXAGON */]: hexagon,
  ["triangle" /* TRIANGLE */]: triangle,
  ["square" /* SQUARE */]: square,
  ["pentagon" /* PENTAGON */]: pentagon,
  ["cylinder" /* CYLINDER */]: circle,
  ["hexagonColumn" /* HEXAGONCOLUMN */]: hexagon,
  ["triangleColumn" /* TRIANGLECOLUMN */]: triangle,
  ["squareColumn" /* SQUARECOLUMN */]: square,
  ["pentagonColumn" /* PENTAGONCOLUMN */]: pentagon
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ShapeType2D,
  ShapeType3D,
  circle,
  geometryShape,
  hexagon,
  pentagon,
  polygonPath,
  square,
  triangle
});
