var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/earth/index.ts
var earth_exports = {};
__export(earth_exports, {
  default: () => EarthLayer
});
module.exports = __toCommonJS(earth_exports);
var import_BaseLayer = __toESM(require("../core/BaseLayer"));
var import_atmosphere = __toESM(require("./models/atmosphere"));
var import_base = __toESM(require("./models/base"));
var import_bloomsphere = __toESM(require("./models/bloomsphere"));
var EarthModels = {
  base: import_base.default,
  atomSphere: import_atmosphere.default,
  bloomSphere: import_bloomsphere.default
};
var earthLayerTypes = ["base", "atomSphere", "bloomSphere"];
var EarthLayer = class extends import_BaseLayer.default {
  constructor() {
    super(...arguments);
    this.type = "EarthLayer";
  }
  buildModels() {
    const shape = this.getModelType();
    this.layerModel = new EarthModels[shape](this);
    this.layerModel.initModels((models) => {
      this.models = models;
      this.renderLayers();
    });
  }
  setEarthTime(time) {
    if (this.layerModel && this.layerModel.setEarthTime) {
      this.layerModel.setEarthTime(time);
    } else {
      console.warn("\u8BF7\u5728 scene loaded \u4E4B\u540E\u6267\u884C\u8BE5\u65B9\u6CD5\uFF01");
    }
  }
  getModelType() {
    var _a;
    const shapeAttribute = this.styleAttributeService.getLayerStyleAttribute("shape");
    let shape = ((_a = shapeAttribute == null ? void 0 : shapeAttribute.scale) == null ? void 0 : _a.field) || "base";
    if (earthLayerTypes.indexOf(shape) < 0) {
      shape = "base";
    }
    return shape;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
