var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/heatmap/index.ts
var heatmap_exports = {};
__export(heatmap_exports, {
  default: () => HeatMapLayer
});
module.exports = __toCommonJS(heatmap_exports);
var import_BaseLayer = __toESM(require("../core/BaseLayer"));
var import_models = __toESM(require("./models"));
var HeatMapLayer = class extends import_BaseLayer.default {
  constructor() {
    super(...arguments);
    this.type = "HeatMapLayer";
  }
  buildModels() {
    const shape = this.getModelType();
    this.layerModel = new import_models.default[shape](this);
    this.layerModel.initModels((models) => {
      this.models = models;
      this.renderLayers();
    });
  }
  rebuildModels() {
    this.layerModel.buildModels((models) => this.models = models);
  }
  renderModels() {
    const shape = this.getModelType();
    if (shape === "heatmap") {
      if (this.layerModel) {
        this.layerModel.render();
      }
      return this;
    }
    if (this.layerModelNeedUpdate) {
      this.layerModel.buildModels((models) => this.models = models);
      this.layerModelNeedUpdate = false;
    }
    this.models.forEach((model) => model.draw({
      uniforms: this.layerModel.getUninforms()
    }));
    return this;
  }
  updateModelData(data) {
    if (data.attributes && data.elements) {
      this.models[0].updateAttributesAndElements(data.attributes, data.elements);
    } else {
      console.warn("data error");
    }
  }
  getConfigSchema() {
    return {
      properties: {
        opacity: {
          type: "number",
          minimum: 0,
          maximum: 1
        }
      }
    };
  }
  getModelType() {
    var _a;
    const shapeAttribute = this.styleAttributeService.getLayerStyleAttribute("shape");
    const { shape3d } = this.getLayerConfig();
    const source = this.getSource();
    const sourceType = source.data.type;
    const shape = ((_a = shapeAttribute == null ? void 0 : shapeAttribute.scale) == null ? void 0 : _a.field) || "heatmap";
    if (shape === "heatmap" || shape === "heatmap3d") {
      return "heatmap";
    }
    if (sourceType === "hexagon") {
      return (shape3d == null ? void 0 : shape3d.indexOf(shape)) === -1 ? "hexagon" : "grid3d";
    }
    if (sourceType === "grid") {
      return (shape3d == null ? void 0 : shape3d.indexOf(shape)) === -1 ? "grid" : "grid3d";
    }
    return "heatmap";
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
