var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/heatmap/models/heatmap.ts
var heatmap_exports = {};
__export(heatmap_exports, {
  default: () => HeatMapModel
});
module.exports = __toCommonJS(heatmap_exports);
var import_l7_core = require("@antv/l7-core");
var import_l7_utils = require("@antv/l7-utils");
var import_gl_matrix = require("gl-matrix");
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var import_BaseModel = __toESM(require("../../core/BaseModel"));
var import_triangulation = require("../../core/triangulation");
var import_heatmap_3d_frag = __toESM(require("../shaders/heatmap_3d_frag.glsl"));
var import_heatmap_3d_vert = __toESM(require("../shaders/heatmap_3d_vert.glsl"));
var import_heatmap_frag = __toESM(require("../shaders/heatmap_frag.glsl"));
var import_heatmap_vert = __toESM(require("../shaders/heatmap_vert.glsl"));
var import_heatmap_framebuffer_frag = __toESM(require("../shaders/heatmap_framebuffer_frag.glsl"));
var import_heatmap_framebuffer_vert = __toESM(require("../shaders/heatmap_framebuffer_vert.glsl"));
var import_triangulation2 = require("../triangulation");
var HeatMapModel = class extends import_BaseModel.default {
  render() {
    const { clear, useFramebuffer } = this.rendererService;
    useFramebuffer(this.heatmapFramerBuffer, () => {
      clear({
        color: [0, 0, 0, 0],
        depth: 1,
        stencil: 0,
        framebuffer: this.heatmapFramerBuffer
      });
      this.drawIntensityMode();
    });
    if (this.layer.styleNeedUpdate) {
      this.updateColorTexture();
    }
    this.shapeType === "heatmap" ? this.drawColorMode() : this.draw3DHeatMap();
  }
  getUninforms() {
    throw new Error("Method not implemented.");
  }
  async initModels(callbackModel) {
    var _a;
    const {
      createFramebuffer,
      clear,
      getViewportSize,
      createTexture2D,
      useFramebuffer
    } = this.rendererService;
    const shapeAttr = this.styleAttributeService.getLayerStyleAttribute("shape");
    const shapeType = ((_a = shapeAttr == null ? void 0 : shapeAttr.scale) == null ? void 0 : _a.field) || "heatmap";
    this.shapeType = shapeType;
    this.intensityModel = await this.buildHeatMapIntensity();
    this.colorModel = shapeType === "heatmap" ? this.buildHeatmapColor() : this.build3dHeatMap();
    const { width, height } = getViewportSize();
    this.heatmapFramerBuffer = createFramebuffer({
      color: createTexture2D({
        width: Math.floor(width / 4),
        height: Math.floor(height / 4),
        wrapS: import_l7_core.gl.CLAMP_TO_EDGE,
        wrapT: import_l7_core.gl.CLAMP_TO_EDGE,
        min: import_l7_core.gl.LINEAR,
        mag: import_l7_core.gl.LINEAR
      }),
      depth: false
    });
    this.updateColorTexture();
    callbackModel([this.intensityModel, this.colorModel]);
  }
  buildModels(callbackModel) {
    this.initModels(callbackModel);
  }
  registerBuiltinAttributes() {
    this.styleAttributeService.registerStyleAttribute({
      name: "dir",
      type: import_l7_core.AttributeType.Attribute,
      descriptor: {
        name: "a_Dir",
        buffer: {
          usage: import_l7_core.gl.DYNAMIC_DRAW,
          data: [],
          type: import_l7_core.gl.FLOAT
        },
        size: 2,
        update: (feature, featureIdx, vertex, attributeIdx) => {
          return [vertex[3], vertex[4]];
        }
      }
    });
    this.styleAttributeService.registerStyleAttribute({
      name: "size",
      type: import_l7_core.AttributeType.Attribute,
      descriptor: {
        name: "a_Size",
        buffer: {
          usage: import_l7_core.gl.DYNAMIC_DRAW,
          data: [],
          type: import_l7_core.gl.FLOAT
        },
        size: 1,
        update: (feature, featureIdx, vertex, attributeIdx) => {
          const { size = 1 } = feature;
          return [size];
        }
      }
    });
  }
  async buildHeatMapIntensity() {
    this.layer.triangulation = import_triangulation.HeatmapTriangulation;
    const model = await this.layer.buildLayerModel({
      moduleName: "heatmapIntensity",
      vertexShader: import_heatmap_framebuffer_vert.default,
      fragmentShader: import_heatmap_framebuffer_frag.default,
      triangulation: import_triangulation.HeatmapTriangulation,
      depth: {
        enable: false
      },
      cull: {
        enable: true,
        face: (0, import_l7_utils.getCullFace)(this.mapService.version)
      },
      blend: {
        enable: true,
        func: {
          srcRGB: import_l7_core.gl.ONE,
          srcAlpha: 1,
          dstRGB: import_l7_core.gl.ONE,
          dstAlpha: 1
        }
      }
    });
    return model;
  }
  buildHeatmapColor() {
    const {
      mask = false,
      maskInside = true
    } = this.layer.getLayerConfig();
    this.shaderModuleService.registerModule("heatmapColor", {
      vs: import_heatmap_vert.default,
      fs: import_heatmap_frag.default
    });
    const { vs, fs, uniforms } = this.shaderModuleService.getModule("heatmapColor");
    const {
      createAttribute,
      createElements,
      createBuffer,
      createModel
    } = this.rendererService;
    return createModel({
      vs,
      fs,
      attributes: {
        a_Position: createAttribute({
          buffer: createBuffer({
            data: [-1, 1, 0, 1, 1, 0, -1, -1, 0, 1, -1, 0],
            type: import_l7_core.gl.FLOAT
          }),
          size: 3
        }),
        a_Uv: createAttribute({
          buffer: createBuffer({
            data: [0, 1, 1, 1, 0, 0, 1, 0],
            type: import_l7_core.gl.FLOAT
          }),
          size: 2
        })
      },
      uniforms: {
        ...uniforms
      },
      depth: {
        enable: false
      },
      blend: this.getBlend(),
      count: 6,
      elements: createElements({
        data: [0, 2, 1, 2, 3, 1],
        type: import_l7_core.gl.UNSIGNED_INT,
        count: 6
      }),
      stencil: (0, import_l7_utils.getMask)(mask, maskInside)
    });
  }
  drawIntensityMode() {
    var _a;
    const {
      opacity,
      intensity = 10,
      radius = 5
    } = this.layer.getLayerConfig();
    (_a = this.intensityModel) == null ? void 0 : _a.draw({
      uniforms: {
        u_opacity: opacity || 1,
        u_radius: radius,
        u_intensity: intensity
      }
    });
  }
  drawColorMode() {
    var _a;
    const {
      opacity
    } = this.layer.getLayerConfig();
    (_a = this.colorModel) == null ? void 0 : _a.draw({
      uniforms: {
        u_opacity: opacity || 1,
        u_colorTexture: this.colorTexture,
        u_texture: this.heatmapFramerBuffer
      }
    });
  }
  draw3DHeatMap() {
    var _a;
    const {
      opacity
    } = this.layer.getLayerConfig();
    const invert = import_gl_matrix.mat4.create();
    import_gl_matrix.mat4.invert(invert, this.cameraService.getViewProjectionMatrixUncentered());
    (_a = this.colorModel) == null ? void 0 : _a.draw({
      uniforms: {
        u_opacity: opacity || 1,
        u_colorTexture: this.colorTexture,
        u_texture: this.heatmapFramerBuffer,
        u_ViewProjectionMatrixUncentered: this.cameraService.getViewProjectionMatrixUncentered(),
        u_InverseViewProjectionMatrix: [...invert]
      }
    });
  }
  build3dHeatMap() {
    const {
      mask = false,
      maskInside = true
    } = this.layer.getLayerConfig();
    const { getViewportSize } = this.rendererService;
    const { width, height } = getViewportSize();
    const triangulation = (0, import_triangulation2.heatMap3DTriangulation)(width / 4, height / 4);
    this.shaderModuleService.registerModule("heatmap3dColor", {
      vs: import_heatmap_3d_vert.default,
      fs: import_heatmap_3d_frag.default
    });
    const { vs, fs, uniforms } = this.shaderModuleService.getModule("heatmap3dColor");
    const {
      createAttribute,
      createElements,
      createBuffer,
      createModel
    } = this.rendererService;
    return createModel({
      vs,
      fs,
      attributes: {
        a_Position: createAttribute({
          buffer: createBuffer({
            data: triangulation.vertices,
            type: import_l7_core.gl.FLOAT
          }),
          size: 3
        }),
        a_Uv: createAttribute({
          buffer: createBuffer({
            data: triangulation.uvs,
            type: import_l7_core.gl.FLOAT
          }),
          size: 2
        })
      },
      primitive: import_l7_core.gl.TRIANGLES,
      uniforms: {
        ...uniforms
      },
      depth: {
        enable: true
      },
      blend: {
        enable: true,
        func: {
          srcRGB: import_l7_core.gl.SRC_ALPHA,
          srcAlpha: 1,
          dstRGB: import_l7_core.gl.ONE_MINUS_SRC_ALPHA,
          dstAlpha: 1
        }
      },
      elements: createElements({
        data: triangulation.indices,
        type: import_l7_core.gl.UNSIGNED_INT,
        count: triangulation.indices.length
      }),
      stencil: (0, import_l7_utils.getMask)(mask, maskInside)
    });
  }
  updateStyle() {
    this.updateColorTexture();
  }
  updateColorTexture() {
    const { createTexture2D } = this.rendererService;
    if (this.texture) {
      this.texture.destroy();
    }
    const {
      rampColors
    } = this.layer.getLayerConfig();
    const imageData = (0, import_l7_utils.generateColorRamp)(rampColors);
    this.colorTexture = createTexture2D({
      data: new Uint8Array(imageData.data),
      width: imageData.width,
      height: imageData.height,
      wrapS: import_l7_core.gl.CLAMP_TO_EDGE,
      wrapT: import_l7_core.gl.CLAMP_TO_EDGE,
      min: import_l7_core.gl.NEAREST,
      mag: import_l7_core.gl.NEAREST,
      flipY: false
    });
  }
};
HeatMapModel = __decorateClass([
  (0, import_inversify.injectable)()
], HeatMapModel);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
