var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/heatmap/triangulation.ts
var triangulation_exports = {};
__export(triangulation_exports, {
  heatMap3DTriangulation: () => heatMap3DTriangulation
});
module.exports = __toCommonJS(triangulation_exports);
function heatMap3DTriangulation(width, height) {
  const indices = [];
  const vertices = [];
  const uvs = [];
  const gridX1 = width + 1;
  const gridY1 = height + 1;
  const widthHalf = width / 2;
  const heightHalf = height / 2;
  for (let iy = 0; iy < gridY1; iy++) {
    const y = iy - heightHalf;
    for (let ix = 0; ix < gridX1; ix++) {
      const x = ix - widthHalf;
      vertices.push(x / widthHalf, -y / heightHalf, 0);
      uvs.push(ix / width);
      uvs.push(1 - iy / height);
    }
  }
  for (let iy = 0; iy < height; iy++) {
    for (let ix = 0; ix < width; ix++) {
      const a = ix + gridX1 * iy;
      const b = ix + gridX1 * (iy + 1);
      const c = ix + 1 + gridX1 * (iy + 1);
      const d = ix + 1 + gridX1 * iy;
      indices.push(a, b, d);
      indices.push(b, c, d);
    }
  }
  return {
    vertices,
    indices,
    uvs
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  heatMap3DTriangulation
});
