var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  BaseLayer: () => import_BaseLayer.default,
  BaseModel: () => import_BaseModel.default,
  CanvasLayer: () => import_canvas.default,
  CityBuildingLayer: () => import_building.default,
  EarthLayer: () => import_earth.default,
  GeometryLayer: () => import_Geometry.default,
  HeatmapLayer: () => import_heatmap.default,
  ImageLayer: () => import_image.default,
  LineLayer: () => import_line.default,
  MaskLayer: () => import_mask.default,
  PointLayer: () => import_point.default,
  PolygonLayer: () => import_polygon.default,
  RasterLayer: () => import_raster.default,
  WindLayer: () => import_wind.default
});
module.exports = __toCommonJS(src_exports);
var import_l7_core = require("@antv/l7-core");
var import_canvas = __toESM(require("./canvas"));
var import_building = __toESM(require("./citybuliding/building"));
var import_BaseLayer = __toESM(require("./core/BaseLayer"));
var import_BaseModel = __toESM(require("./core/BaseModel"));
var import_Geometry = __toESM(require("./Geometry"));
var import_heatmap = __toESM(require("./heatmap"));
var import_image = __toESM(require("./image"));
var import_line = __toESM(require("./line/index"));
var import_point = __toESM(require("./point"));
var import_polygon = __toESM(require("./polygon"));
var import_raster = __toESM(require("./raster"));
var import_earth = __toESM(require("./earth"));
var import_mask = __toESM(require("./mask"));
var import_wind = __toESM(require("./wind"));
var import_DataMappingPlugin = __toESM(require("./plugins/DataMappingPlugin"));
var import_DataSourcePlugin = __toESM(require("./plugins/DataSourcePlugin"));
var import_FeatureScalePlugin = __toESM(require("./plugins/FeatureScalePlugin"));
var import_LayerAnimateStylePlugin = __toESM(require("./plugins/LayerAnimateStylePlugin"));
var import_LayerModelPlugin = __toESM(require("./plugins/LayerModelPlugin"));
var import_LayerStylePlugin = __toESM(require("./plugins/LayerStylePlugin"));
var import_LightingPlugin = __toESM(require("./plugins/LightingPlugin"));
var import_MultiPassRendererPlugin = __toESM(require("./plugins/MultiPassRendererPlugin"));
var import_PixelPickingPlugin = __toESM(require("./plugins/PixelPickingPlugin"));
var import_RegisterStyleAttributePlugin = __toESM(require("./plugins/RegisterStyleAttributePlugin"));
var import_ShaderUniformPlugin = __toESM(require("./plugins/ShaderUniformPlugin"));
var import_UpdateModelPlugin = __toESM(require("./plugins/UpdateModelPlugin"));
var import_UpdateStyleAttributePlugin = __toESM(require("./plugins/UpdateStyleAttributePlugin"));
__reExport(src_exports, require("./core/interface"), module.exports);
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_DataSourcePlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_RegisterStyleAttributePlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_FeatureScalePlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_DataMappingPlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_LayerStylePlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_UpdateStyleAttributePlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_UpdateModelPlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_MultiPassRendererPlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_ShaderUniformPlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_LayerAnimateStylePlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_LightingPlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_PixelPickingPlugin.default).inRequestScope();
import_l7_core.container.bind(import_l7_core.TYPES.ILayerPlugin).to(import_LayerModelPlugin.default).inRequestScope();
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  BaseLayer,
  BaseModel,
  CanvasLayer,
  CityBuildingLayer,
  EarthLayer,
  GeometryLayer,
  HeatmapLayer,
  ImageLayer,
  LineLayer,
  MaskLayer,
  PointLayer,
  PolygonLayer,
  RasterLayer,
  WindLayer
});
