var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/mask/models/fill.ts
var fill_exports = {};
__export(fill_exports, {
  default: () => MaskModel
});
module.exports = __toCommonJS(fill_exports);
var import_l7_core = require("@antv/l7-core");
var import_lodash = require("lodash");
var import_BaseModel = __toESM(require("../../core/BaseModel"));
var import_triangulation = require("../../core/triangulation");
var import_mask_frag = __toESM(require("../shaders/mask_frag.glsl"));
var import_mask_vert = __toESM(require("../shaders/mask_vert.glsl"));
var MaskModel = class extends import_BaseModel.default {
  getUninforms() {
    const {
      opacity = 0
    } = this.layer.getLayerConfig();
    return {
      u_opacity: (0, import_lodash.isNumber)(opacity) ? opacity : 0
    };
  }
  initModels(callbackModel) {
    this.buildModels(callbackModel);
  }
  async buildModels(callbackModel) {
    this.layer.buildLayerModel({
      moduleName: "mask",
      vertexShader: import_mask_vert.default,
      fragmentShader: import_mask_frag.default,
      triangulation: import_triangulation.polygonTriangulation,
      depth: { enable: false },
      blend: this.getBlend(),
      stencil: {
        enable: true,
        mask: 255,
        func: {
          cmp: import_l7_core.gl.ALWAYS,
          ref: 1,
          mask: 255
        },
        opFront: {
          fail: import_l7_core.gl.REPLACE,
          zfail: import_l7_core.gl.REPLACE,
          zpass: import_l7_core.gl.REPLACE
        }
      }
    }).then((model) => {
      callbackModel([model]);
    }).catch((err) => {
      console.warn(err);
      callbackModel([]);
    });
  }
  clearModels() {
    var _a;
    (_a = this.dataTexture) == null ? void 0 : _a.destroy();
    this.layerService.clear();
  }
  registerBuiltinAttributes() {
    return "";
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
