var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/plugins/DataSourcePlugin.ts
var DataSourcePlugin_exports = {};
__export(DataSourcePlugin_exports, {
  default: () => DataSourcePlugin
});
module.exports = __toCommonJS(DataSourcePlugin_exports);
var import_l7_core = require("@antv/l7-core");
var import_l7_source = __toESM(require("@antv/l7-source"));
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var DataSourcePlugin = class {
  apply(layer) {
    this.mapService = layer.getContainer().get(import_l7_core.TYPES.IMapService);
    layer.hooks.init.tap("DataSourcePlugin", () => {
      let source = layer.getSource();
      if (!source) {
        const defaultSourceConfig = import_l7_source.DEFAULT_SOURCE[layer.type] || {
          data: import_l7_source.DEFAULT_DATA,
          options: import_l7_source.DEFAULT_PARSER
        };
        const { data, options } = layer.sourceOption || defaultSourceConfig;
        source = new import_l7_source.default(data, options);
        layer.setSource(source);
      }
      if (source.inited) {
        this.updateClusterData(layer);
      } else {
        source.once("sourceUpdate", () => {
          this.updateClusterData(layer);
        });
      }
    });
    layer.hooks.beforeRenderData.tap("DataSourcePlugin", () => {
      const neeUpdateCluster = this.updateClusterData(layer);
      const dataSourceNeedUpdate = layer.dataState.dataSourceNeedUpdate;
      layer.dataState.dataSourceNeedUpdate = false;
      return neeUpdateCluster || dataSourceNeedUpdate;
    });
  }
  updateClusterData(layer) {
    const source = layer.getSource();
    const cluster = source.cluster;
    const { zoom = 0 } = source.clusterOptions;
    const newZoom = this.mapService.getZoom() - 1;
    const dataSourceNeedUpdate = layer.dataState.dataSourceNeedUpdate;
    if (cluster && dataSourceNeedUpdate) {
      source.updateClusterData(Math.floor(newZoom));
    }
    if (cluster && Math.abs(layer.clusterZoom - newZoom) >= 1) {
      if (zoom !== Math.floor(newZoom)) {
        source.updateClusterData(Math.floor(newZoom));
      }
      layer.clusterZoom = newZoom;
      return true;
    }
    return false;
  }
};
DataSourcePlugin = __decorateClass([
  (0, import_inversify.injectable)()
], DataSourcePlugin);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
