var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/plugins/FeatureScalePlugin.ts
var FeatureScalePlugin_exports = {};
__export(FeatureScalePlugin_exports, {
  default: () => FeatureScalePlugin
});
module.exports = __toCommonJS(FeatureScalePlugin_exports);
var import_l7_core = require("@antv/l7-core");
var import_d3_array = require("d3-array");
var d3interpolate = __toESM(require("d3-interpolate"));
var d3 = __toESM(require("d3-scale"));
var import_inversify = require("inversify");
var import_lodash = require("lodash");
var import_reflect_metadata = require("reflect-metadata");
var dateRegex = /^(?:(?!0000)[0-9]{4}([-/.]+)(?:(?:0?[1-9]|1[0-2])\1(?:0?[1-9]|1[0-9]|2[0-8])|(?:0?[13-9]|1[0-2])\1(?:29|30)|(?:0?[13578]|1[02])\1(?:31))|(?:[0-9]{2}(?:0[48]|[2468][048]|[13579][26])|(?:0[48]|[2468][048]|[13579][26])00)([-/.]?)0?2\2(?:29))(\s+([01]|([01][0-9]|2[0-3])):([0-9]|[0-5][0-9]):([0-9]|[0-5][0-9]))?$/;
var scaleMap = {
  [import_l7_core.ScaleTypes.LINEAR]: d3.scaleLinear,
  [import_l7_core.ScaleTypes.POWER]: d3.scalePow,
  [import_l7_core.ScaleTypes.LOG]: d3.scaleLog,
  [import_l7_core.ScaleTypes.IDENTITY]: d3.scaleIdentity,
  [import_l7_core.ScaleTypes.SEQUENTIAL]: d3.scaleSequential,
  [import_l7_core.ScaleTypes.TIME]: d3.scaleTime,
  [import_l7_core.ScaleTypes.QUANTILE]: d3.scaleQuantile,
  [import_l7_core.ScaleTypes.QUANTIZE]: d3.scaleQuantize,
  [import_l7_core.ScaleTypes.THRESHOLD]: d3.scaleThreshold,
  [import_l7_core.ScaleTypes.CAT]: d3.scaleOrdinal,
  [import_l7_core.ScaleTypes.DIVERGING]: d3.scaleDiverging
};
var FeatureScalePlugin = class {
  constructor() {
    this.scaleCache = {};
    this.scaleOptions = {};
  }
  apply(layer, {
    styleAttributeService
  }) {
    layer.hooks.init.tap("FeatureScalePlugin", () => {
      this.scaleOptions = layer.getScaleOptions();
      const attributes = styleAttributeService.getLayerStyleAttributes();
      const { dataArray } = layer.getSource().data;
      if (dataArray.length === 0) {
        return;
      }
      this.caculateScalesForAttributes(attributes || [], dataArray);
    });
    layer.hooks.beforeRenderData.tap("FeatureScalePlugin", () => {
      this.scaleOptions = layer.getScaleOptions();
      const attributes = styleAttributeService.getLayerStyleAttributes();
      const { dataArray } = layer.getSource().data;
      this.caculateScalesForAttributes(attributes || [], dataArray);
      layer.layerModelNeedUpdate = true;
      return true;
    });
    layer.hooks.beforeRender.tap("FeatureScalePlugin", () => {
      if (layer.layerModelNeedUpdate) {
        return;
      }
      this.scaleOptions = layer.getScaleOptions();
      const attributes = styleAttributeService.getLayerStyleAttributes();
      if (attributes) {
        const { dataArray } = layer.getSource().data;
        if (dataArray.length === 0) {
          return;
        }
        const attributesToRescale = attributes.filter((attribute) => attribute.needRescale);
        if (attributesToRescale.length) {
          this.caculateScalesForAttributes(attributesToRescale, dataArray);
        }
      }
    });
  }
  isNumber(n) {
    return !isNaN(parseFloat(n)) && isFinite(n);
  }
  caculateScalesForAttributes(attributes, dataArray) {
    this.scaleCache = {};
    attributes.forEach((attribute) => {
      if (attribute.scale) {
        const attributeScale = attribute.scale;
        const type = attribute.name;
        attributeScale.names = this.parseFields(attribute.scale.field || []);
        const scales = [];
        attributeScale.names.forEach((field) => {
          var _a;
          scales.push(this.createScale(field, attribute.name, (_a = attribute.scale) == null ? void 0 : _a.values, dataArray));
        });
        if (scales.some((scale) => scale.type === import_l7_core.StyleScaleType.VARIABLE)) {
          attributeScale.type = import_l7_core.StyleScaleType.VARIABLE;
          scales.forEach((scale) => {
            var _a, _b;
            if (!attributeScale.callback && attributeScale.values !== "text") {
              switch ((_a = scale.option) == null ? void 0 : _a.type) {
                case import_l7_core.ScaleTypes.LOG:
                case import_l7_core.ScaleTypes.LINEAR:
                case import_l7_core.ScaleTypes.POWER:
                  if (attributeScale.values && attributeScale.values.length > 2) {
                    const tick = scale.scale.ticks(attributeScale.values.length);
                    scale.scale.domain(tick);
                  }
                  attributeScale.values ? scale.scale.range(attributeScale.values) : scale.scale.range(scale.option.domain);
                  break;
                case import_l7_core.ScaleTypes.QUANTILE:
                case import_l7_core.ScaleTypes.QUANTIZE:
                case import_l7_core.ScaleTypes.THRESHOLD:
                  scale.scale.range(attributeScale.values);
                  break;
                case import_l7_core.ScaleTypes.CAT:
                  attributeScale.values ? scale.scale.range(attributeScale.values) : scale.scale.range(scale.option.domain);
                  break;
                case import_l7_core.ScaleTypes.DIVERGING:
                case import_l7_core.ScaleTypes.SEQUENTIAL:
                  scale.scale.interpolator(d3interpolate.interpolateRgbBasis(attributeScale.values));
                  break;
              }
            }
            if (attributeScale.values === "text") {
              scale.scale.range((_b = scale.option) == null ? void 0 : _b.domain);
            }
          });
        } else {
          attributeScale.type = import_l7_core.StyleScaleType.CONSTANT;
          attributeScale.defaultValues = scales.map((scale, index) => {
            return scale.scale(attributeScale.names[index]);
          });
        }
        attributeScale.scalers = scales.map((scale) => {
          return {
            field: scale.field,
            func: scale.scale,
            option: scale.option
          };
        });
        attribute.needRescale = false;
      }
    });
  }
  parseFields(field) {
    if (Array.isArray(field)) {
      return field;
    }
    if ((0, import_lodash.isString)(field)) {
      return field.split("*");
    }
    return [field];
  }
  createScale(field, name, values, data) {
    var _a, _b;
    const scaleOption = this.scaleOptions[name] && ((_a = this.scaleOptions[name]) == null ? void 0 : _a.field) === field ? this.scaleOptions[name] : this.scaleOptions[field];
    const styleScale = {
      field,
      scale: void 0,
      type: import_l7_core.StyleScaleType.VARIABLE,
      option: scaleOption
    };
    if (!data || !data.length) {
      if (scaleOption && scaleOption.type) {
        styleScale.scale = this.createDefaultScale(scaleOption);
      } else {
        styleScale.scale = d3.scaleOrdinal([field]);
        styleScale.type = import_l7_core.StyleScaleType.CONSTANT;
      }
      return styleScale;
    }
    const firstValue = (_b = data.find((d) => !(0, import_lodash.isNil)(d[field]))) == null ? void 0 : _b[field];
    if (this.isNumber(field) || (0, import_lodash.isNil)(firstValue) && !scaleOption) {
      styleScale.scale = d3.scaleOrdinal([field]);
      styleScale.type = import_l7_core.StyleScaleType.CONSTANT;
    } else {
      let type = scaleOption && scaleOption.type || this.getDefaultType(firstValue);
      if (values === "text") {
        type = import_l7_core.ScaleTypes.CAT;
      }
      const cfg = this.createScaleConfig(type, field, scaleOption, data);
      styleScale.scale = this.createDefaultScale(cfg);
      styleScale.option = cfg;
    }
    return styleScale;
  }
  getDefaultType(firstValue) {
    let type = import_l7_core.ScaleTypes.LINEAR;
    if (typeof firstValue === "string") {
      type = dateRegex.test(firstValue) ? import_l7_core.ScaleTypes.TIME : import_l7_core.ScaleTypes.CAT;
    }
    return type;
  }
  createScaleConfig(type, field, scaleOption, data) {
    const cfg = {
      type
    };
    const values = (data == null ? void 0 : data.map((item) => item[field])) || [];
    if (scaleOption == null ? void 0 : scaleOption.domain) {
      cfg.domain = scaleOption == null ? void 0 : scaleOption.domain;
    } else if (type !== import_l7_core.ScaleTypes.CAT && type !== import_l7_core.ScaleTypes.QUANTILE && type !== import_l7_core.ScaleTypes.DIVERGING) {
      cfg.domain = (0, import_d3_array.extent)(values);
    } else if (type === import_l7_core.ScaleTypes.CAT) {
      cfg.domain = (0, import_lodash.uniq)(values);
    } else if (type === import_l7_core.ScaleTypes.QUANTILE) {
      cfg.domain = values;
    } else if (type === import_l7_core.ScaleTypes.DIVERGING) {
      const minMax = (0, import_d3_array.extent)(values);
      const neutral = (scaleOption == null ? void 0 : scaleOption.neutral) !== void 0 ? scaleOption == null ? void 0 : scaleOption.neutral : (minMax[0] + minMax[1]) / 2;
      cfg.domain = [minMax[0], neutral, minMax[1]];
    }
    return { ...cfg, ...scaleOption };
  }
  createDefaultScale({ type, domain, unknown, clamp, nice }) {
    const scale = scaleMap[type]();
    if (domain && scale.domain) {
      scale.domain(domain);
    }
    if (unknown) {
      scale.unknown(unknown);
    }
    if (clamp !== void 0 && scale.clamp) {
      scale.clamp(clamp);
    }
    if (nice !== void 0 && scale.nice) {
      scale.nice(nice);
    }
    return scale;
  }
};
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.IGlobalConfigService)
], FeatureScalePlugin.prototype, "configService", 2);
FeatureScalePlugin = __decorateClass([
  (0, import_inversify.injectable)()
], FeatureScalePlugin);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
