var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/plugins/LayerModelPlugin.ts
var LayerModelPlugin_exports = {};
__export(LayerModelPlugin_exports, {
  default: () => LayerModelPlugin
});
module.exports = __toCommonJS(LayerModelPlugin_exports);
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var LayerModelPlugin = class {
  initLayerModel(layer) {
    layer.prepareBuildModel();
    layer.buildModels();
    layer.emit("modelLoaded", null);
    layer.styleNeedUpdate = false;
  }
  prepareLayerModel(layer) {
    layer.prepareBuildModel();
    layer.clearModels();
    layer.buildModels();
    layer.emit("modelLoaded", null);
    layer.layerModelNeedUpdate = false;
  }
  apply(layer) {
    layer.hooks.init.tap("LayerModelPlugin", () => {
      layer.inited = true;
      const source = layer.getSource();
      if (source.inited) {
        this.initLayerModel(layer);
      }
    });
    layer.hooks.beforeRenderData.tap("DataSourcePlugin", () => {
      const source = layer.getSource();
      if (source.inited) {
        this.prepareLayerModel(layer);
      } else {
        source.once("sourceUpdate", () => {
          this.prepareLayerModel(layer);
        });
      }
      return false;
    });
  }
};
LayerModelPlugin = __decorateClass([
  (0, import_inversify.injectable)()
], LayerModelPlugin);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
