var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/plugins/LightingPlugin.ts
var LightingPlugin_exports = {};
__export(LightingPlugin_exports, {
  default: () => LightingPlugin,
  generateLightingUniforms: () => generateLightingUniforms
});
module.exports = __toCommonJS(LightingPlugin_exports);
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var lightTypeUniformMap = {
  directional: {
    lights: "u_DirectionalLights",
    num: "u_NumOfDirectionalLights"
  },
  spot: {
    lights: "u_SpotLights",
    num: "u_NumOfSpotLights"
  }
};
var DEFAULT_LIGHT = {
  type: "directional",
  direction: [1, 10.5, 12],
  ambient: [0.2, 0.2, 0.2],
  diffuse: [0.6, 0.6, 0.6],
  specular: [0.1, 0.1, 0.1]
};
var DEFAULT_DIRECTIONAL_LIGHT = {
  direction: [0, 0, 0],
  ambient: [0, 0, 0],
  diffuse: [0, 0, 0],
  specular: [0, 0, 0]
};
var DEFAULT_SPOT_LIGHT = {
  position: [0, 0, 0],
  direction: [0, 0, 0],
  ambient: [0, 0, 0],
  diffuse: [0, 0, 0],
  specular: [0, 0, 0],
  constant: 1,
  linear: 0,
  quadratic: 0,
  angle: 14,
  exponent: 40,
  blur: 5
};
function generateLightingUniforms(lights) {
  const lightsMap = {
    u_DirectionalLights: new Array(3).fill({ ...DEFAULT_DIRECTIONAL_LIGHT }),
    u_NumOfDirectionalLights: 0,
    u_SpotLights: new Array(3).fill({ ...DEFAULT_SPOT_LIGHT }),
    u_NumOfSpotLights: 0
  };
  if (!lights || !lights.length) {
    lights = [DEFAULT_LIGHT];
  }
  lights.forEach(({ type = "directional", ...rest }, i) => {
    const lightsUniformName = lightTypeUniformMap[type].lights;
    const lightsNumUniformName = lightTypeUniformMap[type].num;
    const num = lightsMap[lightsNumUniformName];
    lightsMap[lightsUniformName][num] = {
      ...lightsMap[lightsUniformName][num],
      ...rest
    };
    lightsMap[lightsNumUniformName]++;
  });
  return lightsMap;
}
var LightingPlugin = class {
  apply(layer) {
    layer.hooks.beforeRender.tap("LightingPlugin", () => {
      const { enableLighting } = layer.getLayerConfig();
      if (enableLighting) {
        layer.models.forEach((model) => model.addUniforms({
          ...generateLightingUniforms()
        }));
      }
    });
  }
};
LightingPlugin = __decorateClass([
  (0, import_inversify.injectable)()
], LightingPlugin);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  generateLightingUniforms
});
