var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/plugins/MultiPassRendererPlugin.ts
var MultiPassRendererPlugin_exports = {};
__export(MultiPassRendererPlugin_exports, {
  default: () => MultiPassRendererPlugin
});
module.exports = __toCommonJS(MultiPassRendererPlugin_exports);
var import_l7_core = require("@antv/l7-core");
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var import_multiPassRender = require("../utils/multiPassRender");
var MultiPassRendererPlugin = class {
  apply(layer, {
    rendererService,
    postProcessingPassFactory,
    normalPassFactory
  }) {
    layer.hooks.init.tap("MultiPassRendererPlugin", () => {
      const { enableMultiPassRenderer, passes = [] } = layer.getLayerConfig();
      this.enabled = !!enableMultiPassRenderer && layer.getLayerConfig().enableMultiPassRenderer !== false;
      if (this.enabled) {
        layer.multiPassRenderer = (0, import_multiPassRender.createMultiPassRenderer)(layer, passes, postProcessingPassFactory, normalPassFactory);
        layer.multiPassRenderer.setRenderFlag(true);
      }
    });
    layer.hooks.beforeRender.tap("MultiPassRendererPlugin", () => {
      if (this.enabled) {
        const { width, height } = rendererService.getViewportSize();
        layer.multiPassRenderer.resize(width, height);
      }
    });
  }
};
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.IGlobalConfigService)
], MultiPassRendererPlugin.prototype, "configService", 2);
MultiPassRendererPlugin = __decorateClass([
  (0, import_inversify.injectable)()
], MultiPassRendererPlugin);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
