var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/plugins/PixelPickingPlugin.ts
var PixelPickingPlugin_exports = {};
__export(PixelPickingPlugin_exports, {
  default: () => PixelPickingPlugin
});
module.exports = __toCommonJS(PixelPickingPlugin_exports);
var import_l7_core = require("@antv/l7-core");
var import_l7_utils = require("@antv/l7-utils");
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var PickingStage = {
  NONE: 0,
  ENCODE: 1,
  HIGHLIGHT: 2
};
var PixelPickingPlugin = class {
  apply(layer, {
    rendererService,
    styleAttributeService
  }) {
    layer.hooks.init.tap("PixelPickingPlugin", () => {
      const { enablePicking, enableMultiPassRenderer } = layer.getLayerConfig();
      styleAttributeService.registerStyleAttribute({
        name: "pickingColor",
        type: import_l7_core.AttributeType.Attribute,
        descriptor: {
          name: "a_PickingColor",
          buffer: {
            data: [],
            type: import_l7_core.gl.FLOAT
          },
          size: 3,
          update: (feature, featureIdx) => {
            const { id } = feature;
            return enablePicking ? (0, import_l7_utils.encodePickingColor)(id) : [0, 0, 0];
          }
        }
      });
    });
    layer.hooks.beforePickingEncode.tap("PixelPickingPlugin", () => {
      const { enablePicking } = layer.getLayerConfig();
      if (enablePicking && layer.isVisible()) {
        layer.models.forEach((model) => model.addUniforms({
          u_PickingStage: PickingStage.ENCODE
        }));
      }
    });
    layer.hooks.afterPickingEncode.tap("PixelPickingPlugin", () => {
      const { enablePicking } = layer.getLayerConfig();
      if (enablePicking && layer.isVisible()) {
        layer.models.forEach((model) => model.addUniforms({
          u_PickingStage: PickingStage.HIGHLIGHT
        }));
      }
    });
    layer.hooks.beforeHighlight.tap("PixelPickingPlugin", (pickedColor) => {
      const { highlightColor, activeMix = 0 } = layer.getLayerConfig();
      const highlightColorInArray = typeof highlightColor === "string" ? (0, import_l7_utils.rgb2arr)(highlightColor) : highlightColor || [1, 0, 0, 1];
      layer.updateLayerConfig({
        pickedFeatureID: (0, import_l7_utils.decodePickingColor)(new Uint8Array(pickedColor))
      });
      layer.models.forEach((model) => model.addUniforms({
        u_PickingStage: PickingStage.HIGHLIGHT,
        u_PickingColor: pickedColor,
        u_HighlightColor: highlightColorInArray.map((c) => c * 255),
        u_activeMix: activeMix
      }));
    });
    layer.hooks.beforeSelect.tap("PixelPickingPlugin", (pickedColor) => {
      const { selectColor, selectMix = 0 } = layer.getLayerConfig();
      const highlightColorInArray = typeof selectColor === "string" ? (0, import_l7_utils.rgb2arr)(selectColor) : selectColor || [1, 0, 0, 1];
      layer.updateLayerConfig({
        pickedFeatureID: (0, import_l7_utils.decodePickingColor)(new Uint8Array(pickedColor))
      });
      layer.models.forEach((model) => model.addUniforms({
        u_PickingStage: PickingStage.HIGHLIGHT,
        u_PickingColor: pickedColor,
        u_HighlightColor: highlightColorInArray.map((c) => c * 255),
        u_activeMix: selectMix,
        u_CurrentSelectedId: pickedColor,
        u_SelectColor: highlightColorInArray.map((c) => c * 255),
        u_EnableSelect: 1
      }));
    });
  }
};
PixelPickingPlugin = __decorateClass([
  (0, import_inversify.injectable)()
], PixelPickingPlugin);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
