var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/plugins/RegisterStyleAttributePlugin.ts
var RegisterStyleAttributePlugin_exports = {};
__export(RegisterStyleAttributePlugin_exports, {
  default: () => RegisterStyleAttributePlugin
});
module.exports = __toCommonJS(RegisterStyleAttributePlugin_exports);
var import_l7_core = require("@antv/l7-core");
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var RegisterStyleAttributePlugin = class {
  apply(layer, {
    styleAttributeService
  }) {
    layer.hooks.init.tap("RegisterStyleAttributePlugin", () => {
      this.registerBuiltinAttributes(styleAttributeService);
    });
  }
  registerBuiltinAttributes(styleAttributeService) {
    styleAttributeService.registerStyleAttribute({
      name: "position",
      type: import_l7_core.AttributeType.Attribute,
      descriptor: {
        name: "a_Position",
        buffer: {
          data: [],
          type: import_l7_core.gl.FLOAT
        },
        size: 3,
        update: (feature, featureIdx, vertex) => {
          return vertex.length === 2 ? [vertex[0], vertex[1], 0] : [vertex[0], vertex[1], vertex[2]];
        }
      }
    });
    styleAttributeService.registerStyleAttribute({
      name: "filter",
      type: import_l7_core.AttributeType.Attribute,
      descriptor: {
        name: "filter",
        buffer: {
          usage: import_l7_core.gl.DYNAMIC_DRAW,
          data: [],
          type: import_l7_core.gl.FLOAT
        },
        size: 1,
        update: (feature, featureIdx) => {
          const { filter } = feature;
          return filter ? [1] : [0];
        }
      }
    });
    styleAttributeService.registerStyleAttribute({
      name: "color",
      type: import_l7_core.AttributeType.Attribute,
      descriptor: {
        name: "a_Color",
        buffer: {
          usage: import_l7_core.gl.DYNAMIC_DRAW,
          data: [],
          type: import_l7_core.gl.FLOAT
        },
        size: 4,
        update: (feature, featureIdx) => {
          const { color } = feature;
          return !color || !color.length ? [1, 1, 1, 1] : color;
        }
      }
    });
    styleAttributeService.registerStyleAttribute({
      name: "vertexId",
      type: import_l7_core.AttributeType.Attribute,
      descriptor: {
        name: "a_vertexId",
        buffer: {
          usage: import_l7_core.gl.DYNAMIC_DRAW,
          data: [],
          type: import_l7_core.gl.FLOAT
        },
        size: 1,
        update: (feature, featureIdx, vertex, attributeIdx) => {
          return [featureIdx];
        }
      }
    });
  }
};
RegisterStyleAttributePlugin = __decorateClass([
  (0, import_inversify.injectable)()
], RegisterStyleAttributePlugin);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
