var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/plugins/ShaderUniformPlugin.ts
var ShaderUniformPlugin_exports = {};
__export(ShaderUniformPlugin_exports, {
  default: () => ShaderUniformPlugin
});
module.exports = __toCommonJS(ShaderUniformPlugin_exports);
var import_l7_core = require("@antv/l7-core");
var import_l7_utils = require("@antv/l7-utils");
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var ShaderUniformPlugin = class {
  apply(layer) {
    const version = this.mapService.version;
    let mvp = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
    let sceneCenterMKT = [0, 0];
    layer.hooks.beforeRender.tap("ShaderUniformPlugin", () => {
      const offset = layer.getLayerConfig().tileOrigin;
      this.coordinateSystemService.refresh(offset);
      if (version === "GAODE2.x") {
        const layerCenter = this.getLayerCenter(layer);
        this.mapService.map.customCoords.setCenter(layerCenter);
        this.mapService.setCustomCoordCenter(layerCenter);
        mvp = this.mapService.map.customCoords.getMVPMatrix();
        sceneCenterMKT = this.mapService.getCustomCoordCenter();
      }
      const { width, height } = this.rendererService.getViewportSize();
      layer.models.forEach((model) => {
        model.addUniforms({
          [import_l7_core.CameraUniform.ProjectionMatrix]: this.cameraService.getProjectionMatrix(),
          [import_l7_core.CameraUniform.ViewMatrix]: this.cameraService.getViewMatrix(),
          [import_l7_core.CameraUniform.ViewProjectionMatrix]: this.cameraService.getViewProjectionMatrix(),
          [import_l7_core.CameraUniform.Zoom]: this.cameraService.getZoom(),
          [import_l7_core.CameraUniform.ZoomScale]: this.cameraService.getZoomScale(),
          [import_l7_core.CameraUniform.FocalDistance]: this.cameraService.getFocalDistance(),
          [import_l7_core.CameraUniform.CameraPosition]: this.cameraService.getCameraPosition(),
          [import_l7_core.CoordinateUniform.CoordinateSystem]: this.coordinateSystemService.getCoordinateSystem(),
          [import_l7_core.CoordinateUniform.ViewportCenter]: this.coordinateSystemService.getViewportCenter(),
          [import_l7_core.CoordinateUniform.ViewportCenterProjection]: this.coordinateSystemService.getViewportCenterProjection(),
          [import_l7_core.CoordinateUniform.PixelsPerDegree]: this.coordinateSystemService.getPixelsPerDegree(),
          [import_l7_core.CoordinateUniform.PixelsPerDegree2]: this.coordinateSystemService.getPixelsPerDegree2(),
          [import_l7_core.CoordinateUniform.PixelsPerMeter]: this.coordinateSystemService.getPixelsPerMeter(),
          [import_l7_core.CoordinateUniform.Mvp]: mvp,
          u_SceneCenterMKT: sceneCenterMKT,
          u_ViewportSize: [width, height],
          u_ModelMatrix: this.cameraService.getModelMatrix(),
          u_DevicePixelRatio: import_l7_utils.$window.devicePixelRatio,
          u_PickingBuffer: layer.getLayerConfig().pickingBuffer || 0,
          u_shaderPick: Number(layer.getShaderPickStat())
        });
      });
    });
  }
  getLayerCenter(layer) {
    const source = layer.getSource();
    return source.center;
  }
};
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.ICameraService)
], ShaderUniformPlugin.prototype, "cameraService", 2);
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.ICoordinateSystemService)
], ShaderUniformPlugin.prototype, "coordinateSystemService", 2);
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.IRendererService)
], ShaderUniformPlugin.prototype, "rendererService", 2);
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.IMapService)
], ShaderUniformPlugin.prototype, "mapService", 2);
ShaderUniformPlugin = __decorateClass([
  (0, import_inversify.injectable)()
], ShaderUniformPlugin);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
