var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/polygon/index.ts
var polygon_exports = {};
__export(polygon_exports, {
  default: () => PolygonLayer
});
module.exports = __toCommonJS(polygon_exports);
var import_BaseLayer = __toESM(require("../core/BaseLayer"));
var import_models = __toESM(require("./models/"));
var PolygonLayer = class extends import_BaseLayer.default {
  constructor() {
    super(...arguments);
    this.type = "PolygonLayer";
  }
  buildModels() {
    const shape = this.getModelType();
    this.layerModel = new import_models.default[shape](this);
    this.layerModel.initModels((models) => {
      this.models = models;
      this.renderLayers();
    });
  }
  rebuildModels() {
    this.layerModel.buildModels((models) => this.models = models);
  }
  getConfigSchema() {
    return {
      properties: {
        opacity: {
          type: "number",
          minimum: 0,
          maximum: 1
        }
      }
    };
  }
  getModelType() {
    var _a;
    if (this.layerSource.parser.type === "mvt") {
      return "vectorpolygon";
    }
    const shapeAttribute = this.styleAttributeService.getLayerStyleAttribute("shape");
    const shape = (_a = shapeAttribute == null ? void 0 : shapeAttribute.scale) == null ? void 0 : _a.field;
    if (shape === "fill") {
      return "fill";
    } else if (shape === "extrude") {
      return "extrude";
    } else if (shape === "water") {
      return "water";
    } else if (shape === "ocean") {
      return "ocean";
    } else if (shape === "line") {
      return "line";
    } else if (shape === "tile") {
      return "tile";
    } else {
      return this.getPointModelType();
    }
  }
  getPointModelType() {
    const layerData = this.getEncodedData();
    const { shape2d, shape3d } = this.getLayerConfig();
    const iconMap = this.iconService.getIconMap();
    const item = layerData.find((fe) => {
      return fe.hasOwnProperty("shape");
    });
    if (!item) {
      return "fill";
    } else {
      const shape = item.shape;
      if (shape === "dot") {
        return "point_normal";
      }
      if ((shape2d == null ? void 0 : shape2d.indexOf(shape)) !== -1) {
        return "point_fill";
      }
      if ((shape3d == null ? void 0 : shape3d.indexOf(shape)) !== -1) {
        return "point_extrude";
      }
      if (iconMap.hasOwnProperty(shape)) {
        return "point_image";
      }
      return "text";
    }
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
