var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/tile/manager/tileConfigManager.ts
var tileConfigManager_exports = {};
__export(tileConfigManager_exports, {
  default: () => TileConfigManager
});
module.exports = __toCommonJS(tileConfigManager_exports);
var import_eventemitter3 = __toESM(require("eventemitter3"));
var import_lodash = require("lodash");
var TileConfigManager = class extends import_eventemitter3.default {
  constructor() {
    super();
    this.checkConfigList = [];
    this.cacheConfig = /* @__PURE__ */ new Map();
  }
  setConfig(key, value) {
    if (!this.checkConfigList.includes(key)) {
      this.checkConfigList.push(key);
    }
    this.cacheConfig.set(key, value);
  }
  removeConfig(key) {
    const configIndex = this.checkConfigList.indexOf(key);
    if (configIndex > -1) {
      this.cacheConfig.delete(key);
      this.checkConfigList.splice(configIndex, 1);
    }
  }
  checkConfig(layer) {
    if (!layer.inited) {
      return;
    }
    const layerConfig = layer.getLayerConfig();
    const updateConfigs = [];
    this.checkConfigList.map((key) => {
      var _a;
      const cacheConfig = this.cacheConfig.get(key);
      let currentConfig;
      if (["color", "size", "shape"].includes(key)) {
        currentConfig = (_a = layer.getAttribute(key)) == null ? void 0 : _a.scale;
      } else {
        if (!(key in layerConfig)) {
          return;
        }
        currentConfig = layerConfig[key];
      }
      if (!(0, import_lodash.isEqual)(cacheConfig, currentConfig)) {
        updateConfigs.push(key);
        this.setConfig(key, currentConfig);
      }
    });
    if (updateConfigs.length > 0) {
      console.warn("tile config cache update!", updateConfigs);
      this.emit("updateConfig", updateConfigs);
    }
  }
  getAttributeScale(layer, name) {
    const attribute = layer.getAttribute(name);
    const scaleValue = {
      field: void 0,
      values: void 0,
      callback: void 0
    };
    if (attribute && attribute.scale) {
      const { field, values, callback } = attribute.scale;
      scaleValue.field = field;
      scaleValue.values = values;
      scaleValue.callback = callback;
    }
    return scaleValue;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
