var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/tile/manager/tilePickerManager.ts
var tilePickerManager_exports = {};
__export(tilePickerManager_exports, {
  default: () => TilePickManager
});
module.exports = __toCommonJS(tilePickerManager_exports);
var import_eventemitter3 = require("eventemitter3");
var TilePickManager = class extends import_eventemitter3.EventEmitter {
  constructor(parent, rendererService, pickingService, children, layerService) {
    super();
    this.isLastPicked = false;
    this.parent = parent;
    this.rendererService = rendererService;
    this.pickingService = pickingService;
    this.layerService = layerService;
    this.children = children;
  }
  normalRender(layers) {
    layers.filter((layer) => layer.inited).filter((layer) => layer.isVisible()).map((layer) => {
      layer.hooks.beforeRenderData.call();
      layer.hooks.beforeRender.call();
      if (layer.masks.length > 0) {
        this.rendererService.clear({
          stencil: 0,
          depth: 1,
          framebuffer: null
        });
        layer.masks.map((m) => {
          m.hooks.beforeRenderData.call();
          m.hooks.beforeRender.call();
          m.render();
          m.hooks.afterRender.call();
        });
      }
      layer.render();
      layer.hooks.afterRender.call();
    });
  }
  pickRender(layers, target) {
    if (this.parent.type === "RasterLayer") {
      this.renderMask(this.parent);
    }
    const isPicked = layers.filter((layer) => this.parent.needPick(target.type) && layer.inited && layer.isVisible()).some((layer) => {
      layer.hooks.beforePickingEncode.call();
      if (layer.masks.length > 0) {
        this.rendererService.clear({
          stencil: 0,
          depth: 1,
          framebuffer: null
        });
        layer.masks.map((m) => {
          m.hooks.beforeRender.call();
          m.render();
          m.hooks.afterRender.call();
        });
      }
      layer.renderModels(true);
      layer.hooks.afterPickingEncode.call();
      const layerPicked = this.pickingService.pickFromPickingFBO(layer, target);
      if (layerPicked && this.parent.type !== "RasterLayer") {
        this.emit("pick", {
          type: target.type,
          pickedColors: this.pickingService.pickedColors,
          layer
        });
        this.pickingService.pickedTileLayers = [this.parent];
      }
      return layerPicked;
    });
    if (this.parent.type !== "RasterLayer" && !isPicked && this.isLastPicked && target.type !== "click") {
      this.pickingService.pickedTileLayers = [];
      this.emit("unpick", {});
      this.beforeHighlight([0, 0, 0]);
    }
    this.isLastPicked = isPicked;
    return isPicked;
  }
  clearPick() {
    this.children.filter((child) => child.inited && child.isVisible()).map((layer) => {
      layer.hooks.beforeSelect.call([0, 0, 0]);
    });
    this.pickingService.pickedTileLayers = [];
  }
  beforeHighlight(pickedColors) {
    this.children.filter((child) => child.inited && child.isVisible()).map((child) => {
      child.hooks.beforeHighlight.call(pickedColors);
    });
  }
  beforeSelect(pickedColors) {
    this.children.filter((child) => child.inited && child.isVisible()).map((layer) => {
      layer.hooks.beforeSelect.call(pickedColors);
    });
  }
  renderMask(layer) {
    if (layer.inited && layer.isVisible()) {
      layer.hooks.beforeRender.call();
      if (layer.masks.length > 0) {
        this.rendererService.clear({
          stencil: 0,
          depth: 1,
          framebuffer: null
        });
        layer.masks.map((m) => {
          m.hooks.beforeRender.call();
          m.render();
          m.hooks.afterRender.call();
        });
      }
      layer.hooks.afterRender.call();
    }
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
