var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/tile/tileFactory/index.ts
var tileFactory_exports = {};
__export(tileFactory_exports, {
  getTileFactory: () => getTileFactory
});
module.exports = __toCommonJS(tileFactory_exports);
var import_line = __toESM(require("./line"));
var import_point = __toESM(require("./point"));
var import_polygon = __toESM(require("./polygon"));
var import_raster = __toESM(require("./raster"));
var import_rasterData = __toESM(require("./rasterData"));
__reExport(tileFactory_exports, require("../interface"), module.exports);
function getTileFactory(tileType, parser) {
  switch (tileType) {
    case "PolygonLayer":
      return import_polygon.default;
    case "LineLayer":
      return import_line.default;
    case "PointLayer":
      return import_point.default;
    case "RasterLayer":
      if (parser.dataType === "arraybuffer") {
        return import_rasterData.default;
      } else {
        return import_raster.default;
      }
    default:
      console.warn("Current Tile Not Exist!");
      return import_raster.default;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getTileFactory
});
