var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/tile/tileFactory/rasterData.ts
var rasterData_exports = {};
__export(rasterData_exports, {
  default: () => RasterTiffTile
});
module.exports = __toCommonJS(rasterData_exports);
var import_utils = require("../utils");
var import_base = __toESM(require("./base"));
var import_rasterDataLayer = __toESM(require("./rasterDataLayer"));
var RasterTiffTile = class extends import_base.default {
  constructor(option) {
    super(option);
    this.parentLayer = option.parent;
  }
  createTile(tile, initOptions) {
    const {
      opacity,
      domain,
      clampHigh,
      clampLow,
      rampColors,
      rampColorsData,
      mask
    } = initOptions;
    const rasterdata = tile.data;
    if (!rasterdata.data) {
      console.warn("raster data not exist!");
      return {
        layers: [],
        layerIDList: []
      };
    }
    const layer = new import_rasterDataLayer.default({
      visible: tile.isVisible,
      mask
    }).source(rasterdata.data, {
      parser: {
        type: "raster",
        width: rasterdata.width,
        height: rasterdata.height,
        extent: tile.bboxPolygon.bbox
      }
    }).style({
      opacity,
      domain,
      clampHigh,
      clampLow,
      rampColors,
      rampColorsData
    });
    this.emitEvent([layer], false);
    (0, import_utils.registerLayers)(this.parentLayer, [layer]);
    return {
      layers: [layer],
      layerIDList: [layer.id]
    };
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
