var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/tile/tileFactory/vectorLayer.ts
var vectorLayer_exports = {};
__export(vectorLayer_exports, {
  default: () => VectorLayer
});
module.exports = __toCommonJS(vectorLayer_exports);
var import_BaseLayer = __toESM(require("../../core/BaseLayer"));
var import_tile = __toESM(require("../../line/models/tile"));
var import_text = __toESM(require("../../point/models/text"));
var import_tile2 = __toESM(require("../../point/models/tile"));
var import_tile3 = __toESM(require("../../polygon/models/tile"));
var VectorLayer = class extends import_BaseLayer.default {
  constructor() {
    super(...arguments);
    this.isVector = true;
    this.type = this.layerType;
    this.pickedID = null;
  }
  getPickID() {
    return this.pickedID;
  }
  setPickID() {
    return this.pickedID;
  }
  buildModels() {
    const model = this.getModelType();
    this.layerModel = new model(this);
    this.layerModel.initModels((models) => {
      this.models = models;
      this.renderLayers();
    });
  }
  rebuildModels() {
    this.layerModel.buildModels((models) => this.models = models);
  }
  getModelType() {
    switch (this.layerType) {
      case "PolygonLayer":
        return import_tile3.default;
      case "LineLayer":
        return import_tile.default;
      case "PointLayer":
        return this.getPointModel();
      default:
        return import_tile2.default;
    }
  }
  getPointModel() {
    const layerData = this.getEncodedData();
    const { shape2d } = this.getLayerConfig();
    const item = layerData.find((fe) => {
      return fe.hasOwnProperty("shape");
    });
    if (item) {
      const shape = item.shape;
      if ((shape2d == null ? void 0 : shape2d.indexOf(shape)) !== -1) {
        return import_tile2.default;
      } else {
        return import_text.default;
      }
    } else {
      return import_tile2.default;
    }
  }
  getConfigSchema() {
    return {
      properties: {
        opacity: {
          type: "number",
          minimum: 0,
          maximum: 1
        }
      }
    };
  }
  getDefaultConfig() {
    return {};
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
