var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/tile/tmsTileLayer.ts
var tmsTileLayer_exports = {};
__export(tmsTileLayer_exports, {
  TMSTileLayer: () => TMSTileLayer
});
module.exports = __toCommonJS(tmsTileLayer_exports);
var import_baseTileLayer = __toESM(require("./tileLayer/baseTileLayer"));
var TMSTileLayer = class extends import_baseTileLayer.default {
  constructor() {
    super(...arguments);
    this.type = "TMS";
  }
  tileUnLoad(tile) {
    this.tileLayerManager.removeChilds(tile.layerIDList, false);
  }
  tileUpdate() {
    if (!this.tilesetManager) {
      return;
    }
    this.tilesetManager.tiles.filter((tile) => tile.isLoaded).map((tile) => {
      var _a;
      if (((_a = tile.data) == null ? void 0 : _a.layers) && this.sourceLayer) {
        const vectorTileLayer = tile.data.layers[this.sourceLayer];
        const features = vectorTileLayer == null ? void 0 : vectorTileLayer.features;
        if (!(Array.isArray(features) && features.length > 0)) {
          return;
        }
      }
      if (!tile.parentLayerIDList.includes(this.parent.id)) {
        const { layers, layerIDList } = this.tileLayerManager.createTile(tile);
        tile.parentLayerIDList.push(this.parent.id);
        tile.layerIDList.push(...layerIDList);
        this.tileLayerManager.addChilds(layers);
        this.setPickState(layers);
      } else {
        if (!tile.isVisibleChange) {
          return;
        }
        const layers = this.tileLayerManager.getChilds(tile.layerIDList);
        this.tileLayerManager.updateLayersConfig(layers, "visible", tile.isVisible);
        this.setPickState(layers);
      }
    });
    this.parent.renderLayers();
    if (this.tilesetManager.isLoaded) {
      this.parent.emit("tiles-loaded", this.tilesetManager.currentTiles);
    }
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TMSTileLayer
});
