var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/blend.ts
var blend_exports = {};
__export(blend_exports, {
  BlendTypes: () => BlendTypes
});
module.exports = __toCommonJS(blend_exports);
var import_l7_core = require("@antv/l7-core");
var BlendTypes = {
  [import_l7_core.BlendType.additive]: {
    enable: true,
    func: {
      srcRGB: import_l7_core.gl.ONE,
      dstRGB: import_l7_core.gl.ONE,
      srcAlpha: 1,
      dstAlpha: 1
    }
  },
  [import_l7_core.BlendType.none]: {
    enable: false
  },
  [import_l7_core.BlendType.normal]: {
    enable: true,
    func: {
      srcRGB: import_l7_core.gl.SRC_ALPHA,
      dstRGB: import_l7_core.gl.ONE_MINUS_SRC_ALPHA,
      srcAlpha: 1,
      dstAlpha: 1
    }
  },
  [import_l7_core.BlendType.subtractive]: {
    enable: true,
    func: {
      srcRGB: import_l7_core.gl.ONE,
      dstRGB: import_l7_core.gl.ONE,
      srcAlpha: import_l7_core.gl.ZERO,
      dstAlpha: import_l7_core.gl.ONE_MINUS_SRC_COLOR
    },
    equation: {
      rgb: import_l7_core.gl.FUNC_SUBTRACT,
      alpha: import_l7_core.gl.FUNC_SUBTRACT
    }
  },
  [import_l7_core.BlendType.max]: {
    enable: true,
    func: {
      srcRGB: import_l7_core.gl.ONE,
      dstRGB: import_l7_core.gl.ONE
    },
    equation: {
      rgb: import_l7_core.gl.MAX_EXT
    }
  },
  [import_l7_core.BlendType.min]: {
    enable: true,
    func: {
      srcRGB: import_l7_core.gl.ONE,
      dstRGB: import_l7_core.gl.ONE
    },
    equation: {
      rgb: import_l7_core.gl.MIN_EXT
    }
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  BlendTypes
});
