var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/collision-index.ts
var collision_index_exports = {};
__export(collision_index_exports, {
  default: () => CollisionIndex
});
module.exports = __toCommonJS(collision_index_exports);
var import_gl_matrix = require("gl-matrix");
var import_grid_index = __toESM(require("./grid-index"));
var CollisionIndex = class {
  constructor(width, height) {
    this.viewportPadding = 100;
    this.width = width;
    this.height = height;
    this.viewportPadding = Math.max(width, height);
    this.grid = new import_grid_index.default(width + this.viewportPadding, height + this.viewportPadding, 25);
    this.screenRightBoundary = width + this.viewportPadding;
    this.screenBottomBoundary = height + this.viewportPadding;
    this.gridRightBoundary = width + 2 * this.viewportPadding;
    this.gridBottomBoundary = height + 2 * this.viewportPadding;
  }
  placeCollisionBox(collisionBox) {
    const tlX = collisionBox.x1 + collisionBox.anchorPointX + this.viewportPadding;
    const tlY = collisionBox.y1 + collisionBox.anchorPointY + this.viewportPadding;
    const brX = collisionBox.x2 + collisionBox.anchorPointX + this.viewportPadding;
    const brY = collisionBox.y2 + collisionBox.anchorPointY + this.viewportPadding;
    if (!this.isInsideGrid(tlX, tlY, brX, brY) || this.grid.hitTest(tlX, tlY, brX, brY)) {
      return {
        box: []
      };
    }
    return {
      box: [tlX, tlY, brX, brY]
    };
  }
  insertCollisionBox(box, featureIndex) {
    const key = { featureIndex };
    this.grid.insert(key, box[0], box[1], box[2], box[3]);
  }
  project(mvpMatrix, x, y) {
    const point = import_gl_matrix.vec4.fromValues(x, y, 0, 1);
    const out = import_gl_matrix.vec4.create();
    const mat = import_gl_matrix.mat4.fromValues(...mvpMatrix);
    import_gl_matrix.vec4.transformMat4(out, point, mat);
    return {
      x: (out[0] / out[3] + 1) / 2 * this.width + this.viewportPadding,
      y: (-out[1] / out[3] + 1) / 2 * this.height + this.viewportPadding
    };
  }
  isInsideGrid(x1, y1, x2, y2) {
    return x2 >= 0 && x1 < this.gridRightBoundary && y2 >= 0 && y1 < this.gridBottomBoundary;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
