var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/dataMappingStyle.ts
var dataMappingStyle_exports = {};
__export(dataMappingStyle_exports, {
  handleStyleColor: () => handleStyleColor,
  handleStyleDataMapping: () => handleStyleDataMapping,
  handleStyleFloat: () => handleStyleFloat
});
module.exports = __toCommonJS(dataMappingStyle_exports);
var import_lodash = require("lodash");
function registerStyleAttribute(fieldName, layer, field, values, updateOptions) {
  layer.updateStyleAttribute(fieldName, field, values, updateOptions);
}
function handleStyleDataMapping(configToUpdate, layer) {
  if (configToUpdate.opacity) {
    handleStyleFloat("opacity", layer, configToUpdate.opacity);
  }
  if (configToUpdate.strokeWidth) {
    handleStyleFloat("strokeWidth", layer, configToUpdate.strokeWidth);
  }
  if (configToUpdate.strokeOpacity) {
    handleStyleFloat("strokeOpacity", layer, configToUpdate.strokeOpacity);
  }
  if (configToUpdate.stroke) {
    handleStyleColor("stroke", layer, configToUpdate.stroke);
  }
  if (configToUpdate.offsets) {
    handleStyleOffsets("offsets", layer, configToUpdate.offsets);
  }
  if (configToUpdate.textOffset) {
    handleStyleOffsets("textOffset", layer, configToUpdate.textOffset);
  }
  if (configToUpdate.thetaOffset) {
    handleStyleFloat("thetaOffset", layer, configToUpdate.thetaOffset);
  }
}
function handleStyleFloat(fieldName, layer, styleFloat) {
  if ((0, import_lodash.isString)(styleFloat)) {
    registerStyleAttribute(fieldName, layer, styleFloat, (value) => {
      return value;
    });
  } else if ((0, import_lodash.isNumber)(styleFloat)) {
    registerStyleAttribute(fieldName, layer, [styleFloat], void 0);
  } else if (Array.isArray(styleFloat) && styleFloat.length === 2) {
    if ((0, import_lodash.isString)(styleFloat[0]) && (0, import_lodash.isFunction)(styleFloat[1])) {
      registerStyleAttribute(fieldName, layer, styleFloat[0], styleFloat[1]);
    } else if ((0, import_lodash.isString)(styleFloat[0]) && Array.isArray(styleFloat[1]) && (0, import_lodash.isNumber)(styleFloat[1][0]) && (0, import_lodash.isNumber)(styleFloat[1][1])) {
      registerStyleAttribute(fieldName, layer, styleFloat[0], styleFloat[1]);
    } else {
      registerStyleAttribute(fieldName, layer, [1], void 0);
    }
  } else {
    registerStyleAttribute(fieldName, layer, [1], void 0);
  }
}
function handleStyleOffsets(fieldName, layer, styleOffsets) {
  if ((0, import_lodash.isString)(styleOffsets)) {
    registerStyleAttribute(fieldName, layer, styleOffsets, (value) => {
      return value;
    });
  } else if (Array.isArray(styleOffsets) && styleOffsets.length === 2 && (0, import_lodash.isString)(styleOffsets[0]) && (0, import_lodash.isFunction)(styleOffsets[1])) {
    registerStyleAttribute(fieldName, layer, styleOffsets[0], styleOffsets[1]);
  } else if (Array.isArray(styleOffsets) && styleOffsets.length === 2 && (0, import_lodash.isNumber)(styleOffsets[0]) && (0, import_lodash.isNumber)(styleOffsets[1])) {
    registerStyleAttribute(fieldName, layer, styleOffsets, void 0);
  } else {
    registerStyleAttribute(fieldName, layer, [0, 0], void 0);
  }
}
function handleStyleColor(fieldName, layer, styleColor) {
  if ((0, import_lodash.isString)(styleColor)) {
    registerStyleAttribute(fieldName, layer, styleColor, void 0);
  } else if (Array.isArray(styleColor) && styleColor.length === 2) {
    if ((0, import_lodash.isString)(styleColor[0]) && (0, import_lodash.isFunction)(styleColor[1])) {
      registerStyleAttribute(fieldName, layer, styleColor[0], styleColor[1]);
    } else if ((0, import_lodash.isString)(styleColor[0]) && Array.isArray(styleColor[1]) && styleColor[1].length > 0) {
      registerStyleAttribute(fieldName, layer, styleColor[0], styleColor[1]);
    } else {
      registerStyleAttribute(fieldName, layer, "#fff", void 0);
    }
  } else {
    registerStyleAttribute(fieldName, layer, "#fff", void 0);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handleStyleColor,
  handleStyleDataMapping,
  handleStyleFloat
});
