var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/layerData.ts
var layerData_exports = {};
__export(layerData_exports, {
  calculateData: () => calculateData
});
module.exports = __toCommonJS(layerData_exports);
var import_l7_maps = require("@antv/l7-maps");
var import_l7_source = __toESM(require("@antv/l7-source"));
var import_l7_utils = require("@antv/l7-utils");
function getArrowPoints(p1, p2) {
  const dir = [p2[0] - p1[0], p2[1] - p1[1]];
  const normalizeDir = (0, import_l7_utils.normalize)(dir);
  const arrowPoint = [
    p1[0] + normalizeDir[0] * 1e-4,
    p1[1] + normalizeDir[1] * 1e-4
  ];
  return arrowPoint;
}
function adjustData2Amap2Coordinates(mappedData, mapService) {
  if (mappedData.length > 0 && mapService.version === import_l7_maps.Version["GAODE2.x"]) {
    if (typeof mappedData[0].coordinates[0] === "number") {
      mappedData.filter((d) => !d.originCoordinates).map((d) => {
        d.version = import_l7_maps.Version["GAODE2.x"];
        d.originCoordinates = cloneDeep(d.coordinates);
        d.coordinates = this.mapService.lngLatToCoord(d.coordinates);
      });
    } else {
      mappedData.filter((d) => !d.originCoordinates).map((d) => {
        d.version = import_l7_maps.Version["GAODE2.x"];
        d.originCoordinates = cloneDeep(d.coordinates);
        d.coordinates = this.mapService.lngLatToCoords(d.coordinates);
      });
    }
  }
}
function adjustData2SimpleCoordinates(mappedData, mapService) {
  if (mappedData.length > 0 && mapService.version === import_l7_maps.Version.SIMPLE) {
    mappedData.map((d) => {
      if (!d.simpleCoordinate) {
        d.coordinates = unProjectCoordinates(d.coordinates, mapService);
        d.simpleCoordinate = true;
      }
    });
  }
}
function unProjectCoordinates(coordinates, mapService) {
  if (typeof coordinates[0] === "number") {
    return mapService.simpleMapCoord.unproject(coordinates);
  }
  if (coordinates[0] && coordinates[0][0] instanceof Array) {
    const coords = [];
    coordinates.map((coord) => {
      const c1 = [];
      coord.map((co) => {
        c1.push(mapService.simpleMapCoord.unproject(co));
      });
      coords.push(c1);
    });
    return coords;
  } else {
    const coords = [];
    coordinates.map((coord) => {
      coords.push(mapService.simpleMapCoord.unproject(coord));
    });
    return coords;
  }
}
function applyAttributeMapping(attribute, record, minimumColor) {
  var _a;
  if (!attribute.scale) {
    return [];
  }
  const scalers = ((_a = attribute == null ? void 0 : attribute.scale) == null ? void 0 : _a.scalers) || [];
  const params = [];
  scalers.forEach(({ field }) => {
    var _a2;
    if (record.hasOwnProperty(field) || ((_a2 = attribute.scale) == null ? void 0 : _a2.type) === "variable") {
      params.push(record[field]);
    }
  });
  const mappingResult = attribute.mapping ? attribute.mapping(params) : [];
  if (attribute.name === "color" && !(0, import_l7_utils.isColor)(mappingResult[0])) {
    return [minimumColor];
  }
  return mappingResult;
}
function mapping(attributes, data, fontService, mapService, minimumColor, layer) {
  const {
    arrow = {
      enable: false
    }
  } = layer == null ? void 0 : layer.getLayerConfig();
  const mappedData = data.map((record) => {
    const encodeRecord = {
      id: record._id,
      coordinates: record.coordinates
    };
    attributes.filter((attribute) => attribute.scale !== void 0).forEach((attribute) => {
      let values = applyAttributeMapping(attribute, record, minimumColor);
      attribute.needRemapping = false;
      if (attribute.name === "color") {
        values = values.map((c) => {
          return (0, import_l7_utils.rgb2arr)(c);
        });
      }
      encodeRecord[attribute.name] = Array.isArray(values) && values.length === 1 ? values[0] : values;
      if (attribute.name === "shape") {
        encodeRecord.shape = fontService.getIconFontKey(encodeRecord[attribute.name]);
      }
    });
    if (encodeRecord.shape === "line" && arrow.enable) {
      const coords = encodeRecord.coordinates;
      const arrowPoint = getArrowPoints(coords[0], coords[1]);
      encodeRecord.coordinates.splice(1, 0, arrowPoint, arrowPoint);
    }
    return encodeRecord;
  });
  adjustData2Amap2Coordinates(mappedData, mapService);
  adjustData2SimpleCoordinates(mappedData, mapService);
  return mappedData;
}
function calculateData(layer, fontService, mapService, styleAttributeService, data, options) {
  const source = new import_l7_source.default(data, options);
  const bottomColor = layer.getBottomColor();
  const attributes = styleAttributeService.getLayerStyleAttributes() || [];
  const { dataArray } = source.data;
  const filterData = dataArray;
  const mappedEncodeData = mapping(attributes, filterData, fontService, mapService, bottomColor, layer);
  source.destroy();
  return mappedEncodeData;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  calculateData
});
