var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/multiPassRender.ts
var multiPassRender_exports = {};
__export(multiPassRender_exports, {
  createMultiPassRenderer: () => createMultiPassRenderer,
  normalizePasses: () => normalizePasses
});
module.exports = __toCommonJS(multiPassRender_exports);
function normalizePasses(passes) {
  return passes.map((pass) => {
    if (typeof pass === "string") {
      pass = [pass, {}];
    }
    return pass;
  });
}
function createMultiPassRenderer(layer, passes, postProcessingPassFactory, normalPassFactory) {
  const multiPassRenderer = layer.multiPassRenderer;
  const { enablePicking, enableTAA } = layer.getLayerConfig();
  if (enableTAA) {
    multiPassRenderer.add(normalPassFactory("taa"));
  } else {
    multiPassRenderer.add(normalPassFactory("render"));
  }
  normalizePasses(passes).forEach((pass) => {
    const [passName, initializationOptions] = pass;
    multiPassRenderer.add(postProcessingPassFactory(passName), initializationOptions);
  });
  multiPassRenderer.add(postProcessingPassFactory("copy"));
  return multiPassRenderer;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createMultiPassRenderer,
  normalizePasses
});
