var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/polylineNormal.ts
var polylineNormal_exports = {};
__export(polylineNormal_exports, {
  computeMiter: () => computeMiter,
  computeNormal: () => computeNormal,
  default: () => polylineNormal_default,
  direction: () => direction
});
module.exports = __toCommonJS(polylineNormal_exports);
var import_l7_utils = require("@antv/l7-utils");
var import_gl_matrix = require("gl-matrix");
function computeMiter(tangent, miter, lineA, lineB, halfThick) {
  import_gl_matrix.vec2.add(tangent, lineA, lineB);
  import_gl_matrix.vec2.normalize(tangent, tangent);
  miter = import_gl_matrix.vec2.fromValues(-tangent[1], tangent[0]);
  const tmp = import_gl_matrix.vec2.fromValues(-lineA[1], lineA[0]);
  return halfThick / import_gl_matrix.vec2.dot(miter, tmp);
}
function computeNormal(out, dir) {
  return import_gl_matrix.vec2.set(out, -dir[1], dir[0]);
}
function direction(out, a, b) {
  import_gl_matrix.vec2.sub(out, a, b);
  import_gl_matrix.vec2.normalize(out, out);
  return out;
}
function extrusions(positions, out, miters, point, normal, scale) {
  addNext(out, miters, normal, -scale);
  addNext(out, miters, normal, scale);
  positions.push(point[0], point[1], 0);
  positions.push(point[0], point[1], 0);
}
function addNext(out, miters, normal, length) {
  out.push(normal[0], normal[1], 0);
  miters.push(length);
}
function lineSegmentDistance(b1, a1) {
  const dx = a1[0] - b1[0];
  const dy = a1[1] - b1[1];
  return Math.sqrt(dx * dx + dy * dy);
}
function isPointEqual(a, b) {
  return a[0] === b[0] && a[1] === b[1];
}
function polylineNormal_default(points, closed, indexOffset, isDash = true) {
  const lineA = import_gl_matrix.vec2.fromValues(0, 0);
  const lineB = import_gl_matrix.vec2.fromValues(0, 0);
  const tangent = import_gl_matrix.vec2.fromValues(0, 0);
  const miter = import_gl_matrix.vec2.create();
  let started = false;
  let lineNormal = null;
  const tmp = import_gl_matrix.vec2.create();
  let count = indexOffset || 0;
  const miterLimit = 4;
  const out = [];
  const attrPos = [];
  const attrIndex = [];
  const miters = [];
  const attrDistance = [0, 0];
  if (closed) {
    points = points.slice();
    points.push(points[0]);
  }
  const total = points.length;
  for (let i = 1; i < total; i++) {
    const index = count;
    const last = import_gl_matrix.vec2.fromValues(points[i - 1][0], points[i - 1][1]);
    const cur = import_gl_matrix.vec2.fromValues(points[i][0], points[i][1]);
    let next = i < points.length - 1 ? import_gl_matrix.vec2.fromValues(points[i + 1][0], points[i + 1][1]) : null;
    if (isPointEqual(last, cur)) {
      continue;
    }
    if (next) {
      let nextIndex = i + 1;
      while (next && isPointEqual(cur, next)) {
        next = nextIndex < points.length - 1 ? import_gl_matrix.vec2.fromValues(points[++nextIndex][0], points[nextIndex][1]) : null;
      }
    }
    let d = 0;
    const flatCur = (0, import_l7_utils.aProjectFlat)([cur[0], cur[1]]);
    const flatLast = (0, import_l7_utils.aProjectFlat)([last[0], last[1]]);
    if (isDash) {
      const lineDistance = lineSegmentDistance(flatCur, flatLast);
      d = lineDistance + attrDistance[attrDistance.length - 1];
    }
    direction(lineA, flatCur, flatLast);
    if (!lineNormal) {
      lineNormal = import_gl_matrix.vec2.create();
      computeNormal(lineNormal, lineA);
    }
    if (!started) {
      started = true;
      extrusions(attrPos, out, miters, last, lineNormal, 1);
    }
    attrIndex.push(index + 0, index + 2, index + 1);
    if (!next) {
      computeNormal(lineNormal, lineA);
      extrusions(attrPos, out, miters, cur, lineNormal, 1);
      attrDistance.push(d, d);
      attrIndex.push(index + 1, index + 2, index + 3);
      count += 2;
    } else {
      const flatNext = (0, import_l7_utils.aProjectFlat)([next[0], next[1]]);
      direction(lineB, flatNext, flatCur);
      let miterLen = computeMiter(tangent, import_gl_matrix.vec2.fromValues(miter[0], miter[1]), lineA, lineB, 1);
      const flip = import_gl_matrix.vec2.dot(tangent, lineNormal) < 0 ? -1 : 1;
      const bevel = Math.abs(miterLen) > miterLimit;
      if (Math.abs(miterLen) > 1e3) {
        extrusions(attrPos, out, miters, cur, lineNormal, 1);
        attrIndex.push(index + 1, index + 2, index + 3);
        attrIndex.push(index + 2, index + 4, index + 3);
        computeNormal(tmp, lineB);
        import_gl_matrix.vec2.copy(lineNormal, tmp);
        extrusions(attrPos, out, miters, cur, lineNormal, 1);
        attrDistance.push(d, d, d, d);
        count += 4;
        continue;
      }
      if (bevel) {
        miterLen = miterLimit;
        extrusions(attrPos, out, miters, cur, lineNormal, 1);
        attrIndex.push(index + 1, index + 2, index + 3);
        attrIndex.push(...flip === 1 ? [index + 2, index + 4, index + 5] : [index + 4, index + 5, index + 3]);
        computeNormal(tmp, lineB);
        import_gl_matrix.vec2.copy(lineNormal, tmp);
        extrusions(attrPos, out, miters, cur, lineNormal, 1);
        attrDistance.push(d, d, d, d);
        count += 4;
      } else {
        extrusions(attrPos, out, miters, cur, lineNormal, 1);
        attrIndex.push(index + 1, index + 2, index + 3);
        addNext(out, miters, lineNormal, miterLen * -flip);
        attrPos.push(cur[0], cur[1], 0);
        attrIndex.push(index + 2, index + 4, index + 3);
        attrIndex.push(index + 4, index + 5, index + 6);
        computeNormal(tmp, lineB);
        import_gl_matrix.vec2.copy(lineNormal, tmp);
        extrusions(attrPos, out, miters, cur, lineNormal, 1);
        attrDistance.push(d, d, d, d, d);
        count += 5;
      }
    }
  }
  const pickData = [];
  for (let i = 0; i < miters.length; i++) {
    const totalDistance = attrDistance[attrDistance.length - 1];
    pickData.push(attrPos[i * 3], attrPos[i * 3 + 1], attrPos[i * 3 + 2], attrDistance[i], miters[i], totalDistance);
  }
  return {
    normals: out,
    attrIndex,
    attrPos: pickData
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  computeMiter,
  computeNormal,
  direction
});
