var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/simpleLine.ts
var simpleLine_exports = {};
__export(simpleLine_exports, {
  default: () => ExtrudePolyline,
  direction: () => direction
});
module.exports = __toCommonJS(simpleLine_exports);
var import_l7_utils = require("@antv/l7-utils");
var import_gl_matrix = require("gl-matrix");
var lineA = import_gl_matrix.vec2.create();
function direction(out, a, b) {
  import_gl_matrix.vec2.sub(out, a, b);
  import_gl_matrix.vec2.normalize(out, out);
  return out;
}
var ExtrudePolyline = class {
  constructor() {
    this.started = false;
    this.totalDistance = 0;
    this.currentIndex = 0;
    this.complex = {
      positions: [],
      indices: [],
      startIndex: 0,
      indexes: []
    };
  }
  simpleExtrude(points) {
    const complex = this.complex;
    if (points.length <= 1) {
      return complex;
    }
    this.started = false;
    this.totalDistance = 0;
    const total = points.length;
    let count = complex.startIndex;
    for (let i = 1; i < total; i++) {
      const last = points[i - 1];
      const cur = points[i];
      const amt = this.simpleSegment(complex, count, last, cur);
      count += amt;
    }
    for (let i = 0; i < complex.positions.length / 6; i++) {
      complex.positions[i * 6 + 5] = this.totalDistance;
    }
    return complex;
  }
  simpleSegment(complex, index, last, cur) {
    let count = 0;
    const indices = complex.indices;
    const positions = complex.positions;
    const flatCur = (0, import_l7_utils.aProjectFlat)([cur[0], cur[1]]);
    const flatLast = (0, import_l7_utils.aProjectFlat)([last[0], last[1]]);
    direction(lineA, flatCur, flatLast);
    const segmentDistance = this.lineSegmentDistance(flatCur, flatLast);
    this.totalDistance += segmentDistance;
    if (!this.started) {
      this.started = true;
      this.extrusions(positions, last, this.totalDistance - segmentDistance);
    }
    this.extrusions(positions, cur, this.totalDistance);
    indices.push(index + 0, index + 1, index + 2);
    indices.push(index + 2, index + 1, index + 3);
    count += 2;
    return count;
  }
  extrusions(positions, point, distanceRadio) {
    positions.push(point[0], point[1], point[2] | 0, distanceRadio, 0, point[2] | 0);
    this.complex.indexes.push(this.currentIndex);
    positions.push(point[0], point[1], point[2] | 0, distanceRadio, 0, point[2] | 0);
    this.complex.indexes.push(this.currentIndex);
    this.currentIndex++;
  }
  lineSegmentDistance(b1, a1) {
    const dx = a1[0] - b1[0];
    const dy = a1[1] - b1[1];
    return Math.sqrt(dx * dx + dy * dy);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  direction
});
